Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 184830)
+++ channels/chan_sip.c	(working copy)
@@ -5740,7 +5740,12 @@
 	int fmt;
 	const char *codec;
 
-	codec = pbx_builtin_getvar_helper(p->owner, "SIP_CODEC");
+	if (p->outgoing_call) {
+		codec = pbx_builtin_getvar_helper(p->owner, "SIP_CODEC_OUTBOUND");
+	} else if (!(codec = pbx_builtin_getvar_helper(p->owner, "SIP_CODEC_INBOUND"))) {
+		codec = pbx_builtin_getvar_helper(p->owner, "SIP_CODEC");
+	}
+
 	if (!codec) 
 		return;
 
@@ -9699,6 +9704,7 @@
 
 	if (p->do_history)
 		append_history(p, "ReInv", "Re-invite sent");
+	try_suggested_sip_codec(p);
 	if (t38version)
 		add_t38_sdp(&req, p);
 	else
@@ -10109,8 +10115,10 @@
 			ast_udptl_offered_from_local(p->udptl, 1);
 			ast_debug(1, "T38 is in state %d on channel %s\n", p->t38.state, p->owner ? p->owner->name : "<none>");
 			add_t38_sdp(&req, p);
-		} else if (p->rtp) 
+		} else if (p->rtp) {
+			try_suggested_sip_codec(p);
 			add_sdp(&req, p, FALSE);
+		}
 	} else {
 		if (!p->notify_headers) {
 			add_header_contentLength(&req, 0);
